unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Menus,
  PlayerUtils, Config, ToolWin;

type
    TTimerThread = class(TThread)
    protected
        procedure Kick();
        procedure Execute; override;
    end;

  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    MenuMedia: TMenuItem;
    MenuRewindFirst: TMenuItem;
    MenuMinus60: TMenuItem;
    MenuMinus30: TMenuItem;
    MenuMinus10: TMenuItem;
    MenuPlus10: TMenuItem;
    MenuPlus30: TMenuItem;
    MenuPlus60: TMenuItem;
    MenuEndMinus10: TMenuItem;
    N6: TMenuItem;
    MenuPrevMedia: TMenuItem;
    MenuNextMedia: TMenuItem;
    N7: TMenuItem;
    MenuRename: TMenuItem;
    MenuTrashFile: TMenuItem;
    MenuVolume: TMenuItem;
    MenuMute: TMenuItem;
    MenuVolume10: TMenuItem;
    MenuVolume20: TMenuItem;
    MenuVolume30: TMenuItem;
    MenuVolume40: TMenuItem;
    MenuVolume50: TMenuItem;
    MenuVolume60: TMenuItem;
    MenuVolume70: TMenuItem;
    MenuVolume80: TMenuItem;
    MenuVolume90: TMenuItem;
    MenuVolume100: TMenuItem;
    MenuHelp: TMenuItem;
    MenuConf: TMenuItem;
    MenuVersion: TMenuItem;
    PnlMediaPlayer: TPanel;
    PnlRealPlayer: TPanel;
    StatusBar: TStatusBar;
    Panel4: TPanel;
    LblStatusTxt: TLabel;
    MenuPlayOrPause: TMenuItem;
    Panel2: TPanel;
    ComboMedia: TComboBox;
    N4: TMenuItem;
    MenuSndVol: TMenuItem;
    MenuBalance: TMenuItem;
    MenuBalLeft: TMenuItem;
    MenuBalStereo: TMenuItem;
    MenuBalRight: TMenuItem;
    MenuFile: TMenuItem;
    MenuRecent: TMenuItem;
    MenuMRU1: TMenuItem;
    MenuMRU2: TMenuItem;
    MenuMRU3: TMenuItem;
    MenuMRU4: TMenuItem;
    MenuMRU5: TMenuItem;
    MenuMRU6: TMenuItem;
    MenuMRU7: TMenuItem;
    MenuMRU8: TMenuItem;
    MenuMRU9: TMenuItem;
    MenuMRU10: TMenuItem;
    MenuMRU11: TMenuItem;
    MenuMRU12: TMenuItem;
    MenuMRU13: TMenuItem;
    MenuMRU14: TMenuItem;
    MenuMRU15: TMenuItem;
    MenuMRU16: TMenuItem;
    MenuMRU17: TMenuItem;
    MenuMRU18: TMenuItem;
    MenuMRU19: TMenuItem;
    MenuMRU20: TMenuItem;
    N1: TMenuItem;
    MenuSeek10: TMenuItem;
    MenuSeek20: TMenuItem;
    MenuSeek30: TMenuItem;
    MenuSeek40: TMenuItem;
    MenuSeek50: TMenuItem;
    MenuSeek60: TMenuItem;
    MenuSeek70: TMenuItem;
    MenuSeek80: TMenuItem;
    MenuSeek90: TMenuItem;
    N2: TMenuItem;
    LblCount: TLabel;
    MenuSeek: TMenuItem;
    TbFolder: TToolBar;
    ToolMRU1: TToolButton;
    ToolMRU2: TToolButton;
    ToolMRU3: TToolButton;
    ToolMRU4: TToolButton;
    ToolMRU5: TToolButton;
    ToolMRU6: TToolButton;
    ToolMRU7: TToolButton;
    ToolMRU8: TToolButton;
    ToolMRU9: TToolButton;
    ToolMRU10: TToolButton;
    ToolMRU11: TToolButton;
    ToolMRU12: TToolButton;
    ToolMRU13: TToolButton;
    ToolMRU14: TToolButton;
    ToolMRU15: TToolButton;
    ToolMRU16: TToolButton;
    ToolMRU17: TToolButton;
    ToolMRU18: TToolButton;
    ToolMRU19: TToolButton;
    ToolMRU20: TToolButton;
    N3: TMenuItem;
    MenuSetPriorityAboveNormal: TMenuItem;
    MenuSetPriorityNormal: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MenuMuteClick(Sender: TObject);
    procedure ChangeVolume(Sender: TObject);
    procedure MenuEndMinus10Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuConfClick(Sender: TObject);
    procedure MenuVersionClick(Sender: TObject);
    procedure ComboMediaSelect(Sender: TObject);
    procedure MenuPlayOrPauseClick(Sender: TObject);
    procedure MenuSndVolClick(Sender: TObject);
    procedure MenuBalRightClick(Sender: TObject);
    procedure MenuNextMediaClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MenuTrashFileClick(Sender: TObject);
    procedure MenuRenameClick(Sender: TObject);
    procedure MenuFileClick(Sender: TObject);
    procedure MenuRecentClick(Sender: TObject);
    procedure MenuMRU10Click(Sender: TObject);
    procedure MenuSeek90Click(Sender: TObject);
    procedure MenuSeekClick(Sender: TObject);
    procedure ToolMRU1Click(Sender: TObject);
    procedure MenuSetPriorityNormalClick(Sender: TObject);
  private
    FMediaPlayer: TPlayerCore;
    FRealPlayer: TPlayerCore;
    FPlayer: TPlayerCore;
    procedure ShowStatus(const S: String; const Index: Integer);
    procedure CheckPlayer(const AFileName: String);
    procedure SetNextMedia();
    procedure SetPrevMedia();
  private
    procedure OnMediaChange(Sender: TPlayerCore; const Title: String;
                                const Width, Height: Integer);
    procedure OnStatusChange(Sender: TPlayerCore; const Status: String);
    procedure OnOpenStateChange(Sender: TPlayerCore; const Status: String);
    procedure OnPlayStateChange(Sender: TPlayerCore; const Status: String);
  private
    FTimerThread: TTimerThread;
    procedure UpdateForm();
  private
    FMRUMenus: array[1..MAX_MRU] of TMenuItem;
    procedure DoOpen(const APath: String);
    procedure UpdateTarget();
  private
    FClientWndProc: Pointer;
    FOrgWndProc: Pointer;
    AllocHandle:HWND;
    FStrBuf: TStringList;
    procedure ClientWndProc(var Msg: TMessage);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DropFiles;
  private

  end;

var
  MainForm: TMainForm;

//-----------------------------------------------------------------------------
//  dNp̔閧̒l[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N011.html
const                  
    UNIQUE_NAM: string = '{D629C418-25E1-483F-ADFB-DBCE8356C5D7}';
    UNIQUE_NUM: Cardinal = $00001111;

implementation

uses
    ShellApi, Info, FindFile;

const
    PLAYER_STOP = '~';
    PLAYER_READY = '';
    INDEX_TIME = 0;
    INDEX_SIZE = 1;
    INDEX_DATE = 2;
    INDEX_CANCEL = 3;
    INDEX_OPENSTATE = 4;
    INDEX_PLAYSTATE = 5;

{$R *.dfm}

//=============================================================================
//  TTimerThread implementation
//=============================================================================

//-----------------------------------------------------------------------------
procedure TTimerThread.Kick();
begin
    MainForm.UpdateForm();
end;

//-----------------------------------------------------------------------------
procedure TTimerThread.Execute();
begin
    while not Terminated do
    begin
        Synchronize(Kick);
        Sleep(10);
    end;
end;

//=============================================================================
//  ŋߎgtH_̏
//=============================================================================

//-----------------------------------------------------------------------------
//  pX  
procedure TMainForm.DoOpen(const APath: String);
var
    LPath: String;
begin
    LPath := ExpandUNCFileName(APath);
    //  tH_̏ꍇ̂݋L^Ă
    if DirectoryExists(LPath) then
    begin
        //  ŋߎgtH_ɒǉ
        GConfig.RemoveMRUEntry(LPath);
        GConfig.AddMRUEntry(LPath);
        //  XV
        UpdateTarget();
    end;
    //  Xbhɒǉ
    GFindFileThread.PutPath(LPath);
end;

//=============================================================================
//  TMainForm implementation
//=============================================================================

//-----------------------------------------------------------------------------
//  j[NȃNXw肵ăbZ[WMpEBhE֐[2008/01/16]
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
function AllocMsgWnd(Method: TWndMethod; ClassName:string): HWND;
var
    DummyClass: TWndClass;
begin
    FillChar(DummyClass, SizeOf(TWndClass), #0);
    DummyClass.hInstance := hInstance;
    DummyClass.lpfnWndProc := @DefWindowProc;
    DummyClass.lpszClassName := PChar(ClassName);
    Windows.RegisterClass(DummyClass);
    Result := CreateWindowEx(WS_EX_TOOLWINDOW, DummyClass.lpszClassName,
                             '', WS_POPUP, 0, 0, 0, 0, 0, 0, hInstance, nil);
    if Assigned(Method) then
        SetWindowLong(Result,GWL_WNDPROC,LongInt(Classes.MakeObjectInstance(Method)));
end;

//-----------------------------------------------------------------------------
//  RXgN^[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/Notes/N012.html
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited Create(AOwner);
    // \bhƂĒ`EBhEvV[WGg|Cg쐬
    FClientWndProc := Classes.MakeObjectInstance(ClientWndProc);
    // 쐬łAMDI NCAg̃EBhEvV[WƂ
    // o^ÃGgۑ
    if FClientWndProc <> nil then
    begin
        FOrgWndProc := Pointer(SetWindowLong(ClientHandle, GWL_WNDPROC,
                                            Longint(FClientWndProc)));
    end;
    //  bZ[WMp
    if AllocHandle = 0 then AllocHandle := AllocMsgWnd(ClientWndProc, UNIQUE_NAM);
end;

//-----------------------------------------------------------------------------
//  fXgN^[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
destructor TMainForm.Destroy;
begin
    // fXgN^ŃEBhEvV[Wɖ߂
    if FOrgWndProc <> nil then
    begin
        SetWindowLong(ClientHandle, GWL_WNDPROC, Longint(FOrgWndProc));
    end;
    //  bZ[WMp
    Classes.DeallocateHwnd(AllocHandle);
    AllocHandle := 0;
    inherited;
end;

//-----------------------------------------------------------------------------
//  ւp̃EBhEvV[W[2008/01/16]
//  http://www.borland.co.jp/tips/delphi/dh015/index.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=268
procedure TMainForm.ClientWndProc(var Msg: TMessage);
var
    i: integer;
    LBuf: PChar;
    LCopyData: PCopyDataStruct;
begin
    case Msg.Msg of

    //  ʂ̃CX^X瑗Ăe
    WM_COPYDATA:
        begin
            LCopyData := PCopyDataStruct(Msg.LParam);
            if LCopyData^.dwData = UNIQUE_NUM then
            begin
                LBuf := StrALloc(LCopyData^.cbData);
                try
                    StrCopy(LBuf, LCopyData^.lpData);
                    FStrBuf.CommaText := LBuf;
                finally
                    StrDispose(LBuf);
                end;
                for i := 0 to FStrBuf.Count - 1 do
                begin
                    //  Xbhɒǉ
                    //GFindFileThread.PutPath(FStrBuf.Strings[i]);
                    DoOpen(FStrBuf.Strings[i]);
                end;
            end;
        end;

    //  ̑̑SĂ̏ꍇ
    else
        Msg.Result := CallWindowProc(FOrgWndProc, ClientHandle,
                                        Msg.Msg, Msg.WParam, Msg.LParam);
    end;
end;

//-----------------------------------------------------------------------------
//  tH[\[2008/01/16]
procedure TMainForm.FormShow(Sender: TObject);
var
    i: integer;
begin
    //  NɃACRɃhbvꂽt@C
    for i := 1 to ParamCount do
    begin
        //  Xbhɒǉ
        //GFindFileThread.PutPath(ParamStr(i));
        DoOpen(ParamStr(i));
    end;
end;

//-----------------------------------------------------------------------------
//  GNXv[hbvꂽ̏
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.WMDropFiles(var Msg: TWMDropFiles);
var
    LPathName: Array[0..MAX_PATH] of Char;
    i, LCount: integer;
begin
    //  hbvꂽt@C̐擾
    LCount := DragQueryFile(Msg.Drop, DWORD(-1), LPathName, SizeOf(LPathName));
    for i := 0 to LCount - 1 do
    begin
        //  ꂼ̃t@C擾
        DragQueryFile(Msg.Drop, i, LPathName, SizeOf(LPathName));
        //  Xbhɒǉ
        //GFindFileThread.PutPath(LPathName);
        DoOpen(LPathName);
    end;
    //  hbv
    DragFinish(Msg.Drop);
end;

//-----------------------------------------------------------------------------
//  GNXv[̃hbOAhhbv󂯕t悤ɂ
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0218.txt
procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
    inherited CreateParams(Params);
    Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

//-----------------------------------------------------------------------------
//  Xe[^Xo[ɃbZ[W\
procedure TMainForm.ShowStatus(const S: String; const Index: Integer);
begin
    StatusBar.Panels[index].Text := S;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TMainForm.FormCreate(Sender: TObject);
var
    i: Integer;
    LComponent: TComponent;
begin
    Self.Caption := Application.Title;

    //  ŋߎgtH_p
    for i := 1 to MAX_MRU do
    begin
        LComponent := Self.FindComponent('MenuMRU' + IntToStr(i));
        FMRUMenus[i] := TMenuItem(LComponent);
    end;

    //  ݒǂݍ
    GConfig := TConfig.Create();
    GConfig.LoadConfig(ChangeFileExt(ParamStr(0), '.ini'));
    //  XV
    UpdateTarget();

    //  vC[p̃plݒ
    PnlMediaPlayer.Align := alClient;
    PnlRealPlayer.Align := alClient;
    //  vC[̃CX^X쐬
    FMediaPlayer := TWmpPlayer.Create(PnlMediaPlayer);
    FRealPlayer := TRealPlayer.Create(PnlRealPlayer);
    //  Cxgݒ
    FMediaPlayer.OnMediaChange := Self.OnMediaChange;
    FMediaPlayer.OnStatusChange := Self.OnStatusChange;
    FMediaPlayer.OnOpenStateChange := Self.OnOpenStateChange;
    FMediaPlayer.OnPlayStateChange := Self.OnPlayStateChange;
    FRealPlayer.OnMediaChange := Self.OnMediaChange;
    FRealPlayer.OnStatusChange := Self.OnStatusChange;
    FRealPlayer.OnOpenStateChange := Self.OnOpenStateChange;
    FRealPlayer.OnPlayStateChange := Self.OnPlayStateChange;

    CheckPlayer('');

    LblStatusTxt.Caption := '';
    ShowStatus('', INDEX_TIME);
    ShowStatus('', INDEX_SIZE);
    ShowStatus('', INDEX_DATE);
    ShowStatus('', INDEX_CANCEL);
    ShowStatus('', INDEX_OPENSTATE);
    ShowStatus('', INDEX_PLAYSTATE);

    //  GpXg쐬
    FStrBuf := TStringList.Create;

    //  ^C}[Xbh
    FTimerThread := TTimerThread.Create(False);
    //  XbhJn(쐬͐錾jbg)
    GFindFileThread.Resume();
end;

//-----------------------------------------------------------------------------
//  ړXV
procedure TMainForm.UpdateTarget();
var
    i: Integer;
    LEntry: String;
begin
    for i := Low(FMRUMenus) to High(FMRUMenus) do
    begin
        if (FMRUMenus[i] <> nil) then
        begin
            LEntry := GConfig.GetMRUEntry(i - Low(FMRUMenus));

            TbFolder.Buttons[i - 1].Hint := LEntry;
            TbFolder.Buttons[i - 1].Caption := ExtractFileName(LEntry);
            TbFolder.Buttons[i - 1].Enabled := True;
        end
        else
        begin
            TbFolder.Buttons[i - 1].Hint := '';
            TbFolder.Buttons[i - 1].Caption := '';
            TbFolder.Buttons[i - 1].Enabled := False;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  őOʂɎĂvC[𔻒
procedure TMainForm.CheckPlayer(const AFileName: String);
begin
    if GConfig.CheckReal(AFileName) then
    begin
        PnlRealPlayer.BringToFront();
        FPlayer := FRealPlayer;
    end
    else
    begin
        PnlMediaPlayer.BringToFront();
        FPlayer := FMediaPlayer;
    end;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  ^C}[XbhI
    FTimerThread.Free();
    //  LZ(j͐錾jbg)
    GFindFileThread.Cancel();

    //  ݒۑ
    GConfig.SaveConfig(ChangeFileExt(ParamStr(0), '.ini'));
    GConfig.Free();

    //  GpXgj
    FStrBuf.Free;

    //  FormDestroy ̌ FormResize ݂
    Self.OnResize := nil;
    //  vC[j
    FMediaPlayer.Free();
    FRealPlayer.Free();
end;

//-----------------------------------------------------------------------------
//  fBAύXꂽƂ̃Cxg
procedure TMainForm.OnMediaChange(Sender: TPlayerCore; const Title: String;
                            const Width, Height: Integer);
begin
    Self.Caption := Format('%s %dx%D %s', [Application.Title, Width, Height, Title]);
end;

//-----------------------------------------------------------------------------
//  Xe[^XύXCxg
procedure TMainForm.OnStatusChange(Sender: TPlayerCore; const Status: String);
begin
    LblStatusTxt.Caption := Status;
end;

//-----------------------------------------------------------------------------
//  fBAǂݍݏԃCxg
procedure TMainForm.OnOpenStateChange(Sender: TPlayerCore; const Status: String);
begin
    ShowStatus(Status, INDEX_OPENSTATE);
end;

//-----------------------------------------------------------------------------
//  ĐԃCxg
procedure TMainForm.OnPlayStateChange(Sender: TPlayerCore; const Status: String);
begin
    ShowStatus(Status, INDEX_PLAYSTATE);
end;

//-----------------------------------------------------------------------------
//  vC[tH[̃TCYɍ킹
procedure TMainForm.FormResize(Sender: TObject);
begin
    FMediaPlayer.OnResizeForm();
    FRealPlayer.OnResizeForm();
end;

//-----------------------------------------------------------------------------
//  ~[gؑ
procedure TMainForm.MenuMuteClick(Sender: TObject);
begin
    FPlayer.Mute := not FPlayer.Mute;
end;

//-----------------------------------------------------------------------------
//  {[ݒ
procedure TMainForm.ChangeVolume(Sender: TObject);
begin
    FPlayer.Volume := TComponent(Sender).Tag;
end;

//-----------------------------------------------------------------------------
//  E߂
procedure TMainForm.MenuEndMinus10Click(Sender: TObject);
begin
    //  ŏ܂Ŋ߂
    if (Sender = MenuRewindFirst) then
    begin
        FPlayer.SeekFromBeginning(0);
    end
    else
    //  I肩10bO
    if (Sender = MenuEndMinus10) then
    begin
        FPlayer.SeekFromEnd(10);
    end
    //  ȊÕXLbv
    else
    begin
        FPlayer.SeekFromCurrent(TComponent(Sender).Tag);
    end;
end;

//-----------------------------------------------------------------------------
//  p[ZgXLbv
procedure TMainForm.MenuSeek90Click(Sender: TObject);
begin
    FPlayer.SeekFromBeginning2(TComponent(Sender).Tag);
end;

//-----------------------------------------------------------------------------
//  p[ZgXLbv
procedure TMainForm.MenuSeekClick(Sender: TObject);
begin
    FPlayer.SeekFromCurrent2(TComponent(Sender).Tag);
end;

//-----------------------------------------------------------------------------
//  ݒʕ\
procedure TMainForm.MenuConfClick(Sender: TObject);
begin
    ConfigForm.ShowModal();
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.MenuVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
//  Đ/ꎞ~ؑ
procedure TMainForm.MenuPlayOrPauseClick(Sender: TObject);
begin
    FPlayer.PlayOrPause();
end;

//-----------------------------------------------------------------------------
//  TEhRg[N
procedure TMainForm.MenuSndVolClick(Sender: TObject);
begin
    SimpleShellExecute('sndvol32.exe');
end;

//-----------------------------------------------------------------------------
//  oXύX
procedure TMainForm.MenuBalRightClick(Sender: TObject);
begin
    FPlayer.Balance := TComponent(Sender).Tag;
end;

//-----------------------------------------------------------------------------
//  fBAؑ
procedure TMainForm.MenuNextMediaClick(Sender: TObject);
begin
    if (Sender = MenuNextMedia) then
    begin
        SetNextMedia();
    end
    else
    if (Sender = MenuPrevMedia) then
    begin
        SetPrevMedia();
    end;
end;

//-----------------------------------------------------------------------------
//  ̃fBA
procedure TMainForm.SetNextMedia();
begin
    if (ComboMedia.Items.Count > ComboMedia.ItemIndex + 1) then
    begin
        ComboMedia.ItemIndex := ComboMedia.ItemIndex + 1;
        ComboMedia.OnSelect(ComboMedia);
{
    end
    //  Ȃ΃NA(ǃNAȂ)
    //  status uvɂȂ
    else
    begin
        FPlayer.Source := '';
}
    end;
end;

//-----------------------------------------------------------------------------
//  ÕfBA
procedure TMainForm.SetPrevMedia();
begin
    if (ComboMedia.Items.Count > 0) and (ComboMedia.ItemIndex > 0) then
    begin
        ComboMedia.ItemIndex := ComboMedia.ItemIndex - 1;
        ComboMedia.OnSelect(ComboMedia);
{
    end
    //  OȂ΃NA(ǃNAȂ)
    //  status uvɂȂ
    else
    begin
        ComboMedia.ItemIndex := -1;
        FPlayer.Source := '';
}
    end;
end;

//-----------------------------------------------------------------------------
//  ^C}[
procedure TMainForm.UpdateForm();
var
    s, s1, s2: string;
    d1, d2: Double;
    LBuf: TStringList;
    i: Integer;
    LFileName: String;
begin
    //  hbvt@CfBAXgɒǉ
    if (GFindFileThread.ResultCount > 0) then
    begin
        //  f
        ShowStatus('[ESC] to Break', INDEX_CANCEL);
        if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
        begin
            GFindFileThread.Cancel();
        end;

        LBuf := TStringList.Create();
        LBuf.Sorted := True;
        //GFindFileThread.GetResult(LBuf, 10);
        GFindFileThread.GetResult(LBuf, 30);
        for i := 0 to LBuf.Count - 1 do
        begin
            LFileName := LBuf[i];

            //  `FbN
            if (not GConfig.CheckFile(LFileName)) then Continue;

            //  MediaPlayerōĐ̏ꍇ
            //  vCXgɒǉƖΉ̃t@C͂B
            //  FLVȂǂ̕WȊO(?)̃t@CĐłꍇłB
            //  Ȃ̂ŁAOŃXgǗAĐsourceURLw肷B
            ComboMedia.Items.Add(LFileName);
        end;
    end
    else
    begin
        ShowStatus('', INDEX_CANCEL);
    end;

    //  AĐĂȂΎ̃fBA(hbvȂ)
    if (FPlayer.GetDebugState() in [0, 1]) then
    begin
        SetNextMedia();
    end
    else
    //  AĐĂȂ΍ĐĂ݂()
    //  Ȃ flv t@CȂǕWT|[gÕt@CXLbv
    //  ƍŌ̃fBAxĐĂ܂
    if (FPlayer.GetDebugState() in [10]) then
    begin
        FPlayer.Play();
    end
    ;

    //  ݂̃fBAڂ̕bŎĐ(b)
    s1 := FPlayer.MediaLengthHMS();
    //  fBAړ݈̌ʒu擾(b)
    s2 := FPlayer.CurrentPositionHMS();
    //  ݂̃fBAڂ̕bŎĐ
    d1 := FPlayer.MediaLength();
    //  fBAړ݈̌ʒu擾(ύX\)
    d2 := FPlayer.CurrentPosition();
    //  A
    s := Format('%s(%fb) / %s(%fb)', [s2, d2, s1, d1]);
    //  Đ̃fBA̎ԂɊւ\
    ShowStatus(s, INDEX_TIME);

    //  vCXg̃ACe
    LblCount.Caption := Format('[%d/%d]', [ComboMedia.ItemIndex + 1, ComboMedia.Items.Count]);
end;

//-----------------------------------------------------------------------------
//  fBAI
procedure TMainForm.ComboMediaSelect(Sender: TObject);
var
    LCombo: TComboBox;
    LPath: String;
    LSize: Integer;
    LDateTime: TDateTime;
begin
    LCombo := TComboBox(Sender);
    if (LCombo.ItemIndex = -1) then Exit;
    //  Ôߍ̃fBA~Ă
    FPlayer.Stop();
    //  fBA؂ւ
    LPath := LCombo.Text;
    try
        //  t@C̑݊mF
        if (FileExists(LPath)) then
        begin
            //  łɃTCY\
            LSize := FileSizeByFileSize(LPath);
            ShowStatus(Format('%.2f[MB]', [LSize / (1024 * 1024)]), INDEX_SIZE);

            //  łɍŏIXV\
            LDateTime := FileModifiedByGetFileTime(LPath);
            ShowStatus(FormatDateTime('yyyy/mm/dd hh:nn:ss', LDateTime), INDEX_DATE);

            //  vC[I
            CheckPlayer(LPath);
            FPlayer.Source := LPath;
            FPlayer.Play();
        end
        else
        begin
            SetNextMedia();
        end;
    except
        ;
    end;
end;

//-----------------------------------------------------------------------------
//  񂵊Jn
procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = Ord(GConfig.FastwardKey)) then
    begin
        FPlayer.Rate := GConfig.FastwardRate;
    end;
    if (ssShift in Shift) then TbFolder.Color := clGray;
end;

//-----------------------------------------------------------------------------
//  񂵉
procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    FPlayer.Rate := 1;
    TbFolder.Color := clWhite;
end;

//-----------------------------------------------------------------------------
//  S~Ɏ̂Ă
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=2#0275.txt
function ShTrashFile(const AFileName: String): Boolean;
var
    LText: String;
    LResult: Integer;
    SHF: TSHFileOpStruct;
begin
    LText := Format('t@C%sS~Ɉڂ܂H',
                    [Quote(ExtractFileName(AFileName))]);
    LResult := AppMessageBox(LText, 't@C̍폜̊mF', MB_OKCANCEL or MB_ICONQUESTION);
    if (LResult <> IDOK) then
    begin
        Result := False;
    end
    else
    begin
        FillChar(SHF, SizeOf(SHF), 0);
        SHF.Wnd    := Application.Handle;
        SHF.wFunc  := FO_DELETE;
        SHF.pFrom  := PChar(AFileName + #0);
        SHF.fFlags := FOF_ALLOWUNDO or FOF_NOCONFIRMATION or FOF_NOERRORUI;
        LResult := SHFileOperation(SHF);
        Result := (LResult = 0);
    end;
end;

//-----------------------------------------------------------------------------
//  ړ
function ShMoveFile(const ACurName, ANewName: String): Boolean;
var
    LResult: Integer;
    SHF: TSHFileOpStruct;
begin
    FillChar(SHF, SizeOf(SHF), 0);
    SHF.Wnd    := Application.Handle;
    SHF.wFunc  := FO_MOVE;
    SHF.pFrom  := PChar(ACurName + #0);
    SHF.pTo  := PChar(ANewName + #0);
    SHF.fFlags := FOF_FILESONLY or FOF_NOCONFIRMATION;
    LResult := SHFileOperation(SHF);
    Result := (LResult = 0);
end;

//-----------------------------------------------------------------------------
//  Đ̃t@CS~Ɏ̂Ă
procedure TMainForm.MenuTrashFileClick(Sender: TObject);
var
    LIndex: Integer;
begin
    if (ComboMedia.ItemIndex = -1) then Exit;
    if (FPlayer.Source = ComboMedia.Text) then
    begin
        if (ShTrashFile(ComboMedia.Text)) then
        begin
            LIndex := ComboMedia.ItemIndex;
            SetNextMedia();
            ComboMedia.Items.Delete(LIndex);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  t@C`FbN
function CheckValidFileName(const ACheckName: String): Boolean;
const
    INVALID_CHARS = '\/:*?"<>|';
var
    i: Integer;
    LTemp: String;
begin
    LTemp := ACheckName;
    for i := 1 to Length(INVALID_CHARS) do
    begin
        LTemp := StringReplace(LTemp, INVALID_CHARS[i], '', [rfReplaceAll]);
    end;
    if (LTemp = '') then Result := False
    else if (LTemp[1] = '.') then Result := False
    else Result := True;
end;

//-----------------------------------------------------------------------------
//  Đ̃t@C̖OύX
procedure TMainForm.MenuRenameClick(Sender: TObject);
var
    LIndex: Integer;
    LMediaName: String;
    LFullPath: String;
    LDirPath: String;
    LExt: String;
    LOldName: String;
    LNewName: String;
    LNewPath: String;
    LChange: Boolean;
begin
    if (ComboMedia.ItemIndex = -1) then Exit;
    if (FPlayer.Source = ComboMedia.Text) then
    begin
        LIndex := ComboMedia.ItemIndex;

        LMediaName := FPlayer.Title;
        LFullPath := FPlayer.Source;
        LDirPath := ExtractFilePath(LFullPath);

        LOldName := ChangeFileExt(ExtractFileName(LFullPath), '');
        LExt := ExtractFileExt(LFullPath);

        LNewName := LOldName;
        if (LOldName <> LMediaName) then
        begin
           LNewName := LNewName + LMediaName;
        end;

        LChange := InputQuery(
                    't@CύX',
                    LDirPath + #13#10 + LOldName + #13#10 + LExt,
                    LNewName);
        if (LChange) and CheckValidFileName(LNewName) then
        begin
            LNewPath := LDirPath + LNewName + LExt;
            if (not FileExists(LNewPath)) and (RenameFile(LFullPath, LNewPath)) then
            begin
                ComboMedia.Items[LIndex] := LNewPath;
                ComboMedia.ItemIndex := LIndex;
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  t@Cj[NbN
procedure TMainForm.MenuFileClick(Sender: TObject);
begin
    MenuRecent.Enabled := (GConfig.MRUCount > 0);
end;

//-----------------------------------------------------------------------------
//  ŋߎgtH_NbN
procedure TMainForm.MenuRecentClick(Sender: TObject);
var
    i: Integer;
    LEntry: String;
begin
    for i := Low(FMRUMenus) to High(FMRUMenus) do
    begin
        if (FMRUMenus[i] <> nil) then
        begin
            LEntry := GConfig.GetMRUEntry(i - Low(FMRUMenus));
            FMRUMenus[i].Visible := (LEntry <> '');
            FMRUMenus[i].Caption := LEntry;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ŋߎgtH_̂ꂼNbN
procedure TMainForm.MenuMRU10Click(Sender: TObject);
var
    i: Integer;
    LEntry: String;
begin
    for i := Low(FMRUMenus) to High(FMRUMenus) do
    begin
        if (Sender = FMRUMenus[i]) then
        begin
            LEntry := GConfig.GetMRUEntry(i - 1);
            if (DirectoryExists(LEntry) or FileExists(LEntry)) then
            begin
                DoOpen(LEntry);
            end
            else
            begin
                GConfig.RemoveMRUEntry(LEntry);
            end;
            //  XV
            UpdateTarget();
            Break;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ŋߎgtH_NbN(c[{^)
//  ShiftL[ł̃tH_Ɉړ
procedure TMainForm.ToolMRU1Click(Sender: TObject);
var
    LSender: TToolButton;
    LEntry: String;
var
    LIndex: Integer;
    LFileName: String;
    LCurPath: String;
    LNewPath: String;
begin
    LSender := TToolButton(Sender);
    LEntry := GConfig.GetMRUEntry(LSender.Index);

    //  ShiftĂ΁AĐ̃fBÃtH_Ɉړ
    if ((GetAsyncKeyState(VK_SHIFT) and $8000) <> 0) then
    begin
        if (DirectoryExists(LEntry)) then
        begin
            LIndex := ComboMedia.ItemIndex;
            LCurPath := FPlayer.Source;
            if (FileExists(LCurPath)) then
            begin
                LFileName := ExtractFileName(LCurPath);
                LNewPath := IncludeTrailingPathDelimiter(LEntry) + LFileName;
                if (not FileExists(LNewPath)) then
                begin
                    if (ShMoveFile(LCurPath, LNewPath)) then
                    begin
                        ComboMedia.Items[LIndex] := LNewPath;
                        ComboMedia.ItemIndex := LIndex;
                    end;
                end;
            end;
        end;
    end
    //  ̃tH_̒̃fBAXgɉ
    else
    begin
        if (DirectoryExists(LEntry) or FileExists(LEntry)) then
        begin
            DoOpen(LEntry);
        end
        else
        begin
            GConfig.RemoveMRUEntry(LEntry);
        end;
        //  XV
        UpdateTarget();
    end;
end;

//-----------------------------------------------------------------------------
//  GetPriorityClass ̖߂l
const
    ABOVE_NORMAL_PRIORITY_CLASS = $00008000;
    BELOW_NORMAL_PRIORITY_CLASS = $00004000;
    HIGH_PRIORITY_CLASS         = $00000080;
    IDLE_PRIORITY_CLASS         = $00000040;
    NORMAL_PRIORITY_CLASS       = $00000020;
    REALTIME_PRIORITY_CLASS     = $00000100;

//-----------------------------------------------------------------------------
//  {DxύX
procedure TMainForm.MenuSetPriorityNormalClick(Sender: TObject);
var
    LPriority: DWORD;
    LText: String;
begin
    LPriority := NORMAL_PRIORITY_CLASS;
    if (Sender = MenuSetPriorityAboveNormal) then
    begin
        LPriority := ABOVE_NORMAL_PRIORITY_CLASS;
    end;
    {LResult := }SetPriorityClass(GetCurrentProcess(), LPriority);

    LPriority := GetPriorityClass(GetCurrentProcess());
    if (LPriority = 0) then
    begin
        LText := SysErrorMessage(GetLastError());
    end
    else
    begin
        case LPriority of
        ABOVE_NORMAL_PRIORITY_CLASS : LText := 'ABOVE_NORMAL_PRIORITY_CLASS';
        BELOW_NORMAL_PRIORITY_CLASS : LText := 'BELOW_NORMAL_PRIORITY_CLASS';
        HIGH_PRIORITY_CLASS         : LText := 'HIGH_PRIORITY_CLASS';
        IDLE_PRIORITY_CLASS         : LText := 'IDLE_PRIORITY_CLASS';
        NORMAL_PRIORITY_CLASS       : LText := 'NORMAL_PRIORITY_CLASS';
        REALTIME_PRIORITY_CLASS     : LText := 'REALTIME_PRIORITY_CLASS';
        else LText := 'NORMAL_PRIORITY_CLASS';
        end;
    end;
    LblStatusTxt.Caption := LText;
end;

end.
